# JavaScript

Namespace: **Wisej.Web**

Assembly: **Wisej.Framework** (4.0.0.0)

* [Component](/api/wisej.base/general/wisej.base.component.md)
  * [Component](/api/wisej.web/general/wisej.web.component.md)
    * [JavaScript](/api/wisej.web/extenders/javascript.md)

Allows controls to execute javascript code.

{% tabs %}
{% tab title="C#" %}

```csharp
public class JavaScript : Component, IExtenderProvider
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Class JavaScript
    Inherits Component
    Implements IExtenderProvider
```

{% endtab %}
{% endtabs %}

## Constructors

### ![](/files/hsR4ok3152WyAf8J2C1u) JavaScript()

Initializes a new instance of the [JavaScript](/api/wisej.web/extenders/javascript.md) without a specified container.

### ![](/files/hsR4ok3152WyAf8J2C1u) JavaScript(container)

Initializes a new instance of the [JavaScript](/api/wisej.web/extenders/javascript.md) class with a specified container.

| Name          | Type                                                                                 | Description                                                                                                                                                                                 |
| ------------- | ------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **container** | [IContainer](https://docs.microsoft.com/dotnet/api/system.componentmodel.icontainer) | An [IContainer](https://docs.microsoft.com/dotnet/api/system.componentmodel.icontainer) that represents the container of the [JavaScript](/api/wisej.web/extenders/javascript.md) extender. |

## Properties

### ![](/files/hsR4ok3152WyAf8J2C1u) Tag

[Object](https://docs.microsoft.com/dotnet/api/system.object): Returns or sets the object that contains programmer-supplied data associated with the [JavaScript](/api/wisej.web/extenders/javascript.md) extender. (Default: `null`)

## Methods

### ![](/files/hsR4ok3152WyAf8J2C1u) CanExtend(target)

Returns true if the JavaScript extender can offer an extender property to the specified target component.

| Parameter  | Type                                                          | Description                                       |
| ---------- | ------------------------------------------------------------- | ------------------------------------------------- |
| **target** | [Object](https://docs.microsoft.com/dotnet/api/system.object) | The target object to add an extender property to. |

**Returns:** [Boolean](https://docs.microsoft.com/dotnet/api/system.boolean). true if the [JavaScript](/api/wisej.web/extenders/javascript.md) class can offer one or more extender properties; otherwise, false.

### ![](/files/hsR4ok3152WyAf8J2C1u) Clear()

Removes all scripts.

### ![](/files/lzopMboA31bVq8UIcbT3) Dispose(disposing)

Disposes the component and removes it from the design container.

| Parameter     | Type                                                            | Description                                                                 |
| ------------- | --------------------------------------------------------------- | --------------------------------------------------------------------------- |
| **disposing** | [Boolean](https://docs.microsoft.com/dotnet/api/system.boolean) | true when this method is called by the application rather than a finalizer. |

### ![](/files/hsR4ok3152WyAf8J2C1u) GetJavaScript(control)

Retrieves the JavaScript code associated with the specified control. The JavaScript code will be execute on the client when the control is created or refreshed.

| Parameter   | Type                                         | Description                                                                                 |
| ----------- | -------------------------------------------- | ------------------------------------------------------------------------------------------- |
| **control** | [Control](/api/wisej.web/general/control.md) | The [Control](/api/wisej.web/general/control.md) for which to retrieve the JavaScript code. |

**Returns:** [String](https://docs.microsoft.com/dotnet/api/system.string). A [String](https://docs.microsoft.com/dotnet/api/system.string) containing the javascript code for the specified control.

### ![](/files/hsR4ok3152WyAf8J2C1u) GetJavaScriptEvents(control)

Returns the collection of JavaScript event handlers associated with the control.

| Parameter   | Type                                         | Description                                                                                  |
| ----------- | -------------------------------------------- | -------------------------------------------------------------------------------------------- |
| **control** | [Control](/api/wisej.web/general/control.md) | The [Control](/api/wisej.web/general/control.md) to attach the JavaScript event handlers to. |

**Returns:** [ClientEventCollection](/api/wisej.web/general/control/wisej.web.javascript.clienteventcollection.md).

### ![](/files/hsR4ok3152WyAf8J2C1u) GetJavaScriptSource(control)

Retrieves the JavaScript file associated with the specified control. The JavaScript code will be execute on the client when the control is created or refreshed.

| Parameter   | Type                                         | Description                                                                                 |
| ----------- | -------------------------------------------- | ------------------------------------------------------------------------------------------- |
| **control** | [Control](/api/wisej.web/general/control.md) | The [Control](/api/wisej.web/general/control.md) for which to retrieve the JavaScript file. |

**Returns:** [String](https://docs.microsoft.com/dotnet/api/system.string). A [String](https://docs.microsoft.com/dotnet/api/system.string) containing the name of the javascript file for the specified control.

### ![](/files/lzopMboA31bVq8UIcbT3) OnWebRender(config)

Renders the client component.

| Parameter  | Type                                                          | Description                   |
| ---------- | ------------------------------------------------------------- | ----------------------------- |
| **config** | [Object](https://docs.microsoft.com/dotnet/api/system.object) | Dynamic configuration object. |

### ![](/files/hsR4ok3152WyAf8J2C1u) SetJavaScript(control, script)

Associates JavaScript code with the specified control.

| Parameter   | Type                                                          | Description                                                                        |
| ----------- | ------------------------------------------------------------- | ---------------------------------------------------------------------------------- |
| **control** | [Control](/api/wisej.web/general/control.md)                  | The [Control](/api/wisej.web/general/control.md) to associate the JavaScript with. |
| **script**  | [String](https://docs.microsoft.com/dotnet/api/system.string) | The JavaScript code to execute when the control is created.                        |

### ![](/files/hsR4ok3152WyAf8J2C1u) SetJavaScriptSource(control, file)

Associates JavaScript file with the specified control.

| Parameter   | Type                                                          | Description                                                                             |
| ----------- | ------------------------------------------------------------- | --------------------------------------------------------------------------------------- |
| **control** | [Control](/api/wisej.web/general/control.md)                  | The [Control](/api/wisej.web/general/control.md) to associate the JavaScript file with. |
| **file**    | [String](https://docs.microsoft.com/dotnet/api/system.string) | The JavaScript file to execute when the control is created.                             |

## Implements

| Name                                                                              | Description                                                                                                     |
| --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- |
| [IUserData](/api/wisej.web/interfaces/wisej.web.iuserdata.md)                     | Provides access to the `UserData` and `Tag` properties associated to the component implementing this interface. |
| [IWisejComponent](/api/wisej.core/interfaces/wisej.core.iwisejcomponent.md)       | All wisej components implement this interface.                                                                  |
| [IWisejSerializable](/api/wisej.core/interfaces/wisej.core.iwisejserializable.md) | Allows an object to serialize itself.                                                                           |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.wisej.com/api/wisej.web/extenders/javascript.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
